/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aecommands.h
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#ifndef AECOMMANDS_H_
#define AECOMMANDS_H_

typedef enum
{
    aeCmd_eNull = 0,

    /* Application */
    aeCmd_eQuit,

    /* File */
    aeCmd_eFile_Open,
    aeCmd_eFile_Save,
    aeCmd_eFile_SaveAs,
    aeCmd_eFile_New,
    aeCmd_eFile_ExportGif,

    /* Animation */
    aeCmd_eAnim_Name,
    aeCmd_eAnim_Frame_Append,
    aeCmd_eAnim_Frame_Duplicate,
    aeCmd_eAnim_Frame_Delete,
    aeCmd_eAnim_Frame_Clear,
    aeCmd_eAnim_Frame_Invert,
    aeCmd_eAnim_Speed_Increase,
    aeCmd_eAnim_Speed_Decrease,
    aeCmd_eAnim_Repeat_Increase,
    aeCmd_eAnim_Repeat_Decrease,
    aeCmd_eAnim_FrameIndex_First,
    aeCmd_eAnim_FrameIndex_Prev,
    aeCmd_eAnim_FrameIndex_Next,
    aeCmd_eAnim_FrameIndex_Last,
    aeCmd_eAnim_WrapStyle_Toggle,
    aeCmd_eAnim_Strip_Rotate,
    aeCmd_eAnim_RunLength_Increase,
    aeCmd_eAnim_RunLength_Decrease,
    aeCmd_eAnim_Variant_Add,
    aeCmd_eAnim_Variant_Remove,
    aeCmd_eAnim_Variant_Prev,
    aeCmd_eAnim_Variant_Next,
    aeCmd_eAnim_Variant_Name,
    
    /* Sequences */
    aeCmd_eSequence_AttachAnim,     /* Add to sequence list */
    aeCmd_eSequence_DetachAnim,     /* Break from sequence list */
    aeCmd_eSequence_EditAnim,       /* Open animation for editing */
    aeCmd_eSequence_BringFront,     /* Bring sequence window to the front */
    aeCmd_eSequence_SelectPrev,     /* Select previous sequence */
    aeCmd_eSequence_SelectNext,
    aeCmd_eSequence_MoveUp,         /* Move selected sequence up */
    aeCmd_eSequence_MoveDown,
    aeCmd_eSequence_Delete,         /* Delete animation */
    aeCmd_eSequence_ToggleActive,
    aeCmd_eSequence_ActiveSet_Append,
    aeCmd_eSequence_ActiveSet_Delete,
    aeCmd_eSequence_ActiveSet_Prev,
    aeCmd_eSequence_ActiveSet_Next,
    aeCmd_eSequence_Animated_Prev,
    aeCmd_eSequence_Animated_Next,
    aeCmd_eSequence_Variant_Prev,
    aeCmd_eSequence_Variant_Next,
    
    
    
    /* Count */
    aeCmd_eCount
} aeCommand_t;


#endif /* AECOMMANDS_H_ */
