/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aefileio.c
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#include "astd.h"
#include "aetypes.h"
#include "aefileio.h"

#include <stdio.h>
#include <strings.h>

/*----------------------------------------------------------------------
Summary
    

Desc
    
----------------------------------------------------------------------*/
char aeIO_RemovePrefixSuffix(char* line, char* prefix, char* suffix, char*outline, int outlinelen)
{
    char matches = TRUE;

    /* Quick hack */
    strcpy(outline, line  + strlen(prefix));

    return matches;
}



/*----------------------------------------------------------------------
Summary
    

Desc
    
----------------------------------------------------------------------*/
aErr_t aeIO_ReadLineFromFile(FILE* infile, char* buffer, int lineLen)
{
	int		len = 0;
	char	done = FALSE;
	char	hasError = FALSE;
	int		c;

    memset(buffer, 0, lineLen);

	do
	{
		c = getc(infile);
		
		if (c == '\n' || c == '\r' || c == EOF)
			done = TRUE;
		else
			buffer[len++] = c;
		
		if (ferror(infile) != 0)
		{
			hasError = (c != EOF);
			//BRCM_DBG_WRN(("Error during prefs file read"));
		}

        #if 0
		if (done && c != EOF)
		{
			/* Was it an empty line */
			if (len == 0)
			{
				done = FALSE;
				len = 0;
			}
		}
        #endif

	} while (!done && !hasError);
	
	buffer[len] = 0;
	
	return hasError ? AERR_END_OF_FILE : AERR_NO_ERROR;
}

