/*
	aio.h
	
	Animator I/O
*/


#include "astd.h"

typedef struct aioContext_t aioContext_t;


aioContext_t aioContext_Create(void);
void         aioContext_Delete(aioContext_t* context);

aErr_t       aioContext_Read(aioContext_t*, char* buffer, unsigned int* len);
aErr_t       aioContext_Write(aioContext_t*, char* buffer, unsigned int len);


aioContext_t aioContext_Create_FileWrite(char* path);
aioContext_t aioContext_Create_FileRead(char* path);
aioContext_t aioContext_Create_MemoryWrite(char* buffer, unsigned int size);
aioContext_t aioContext_Create_MemoryRead(char* buffer, unsigned int size);


