/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aedebug.c
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#include "aedebug.h"

#include <windows.h>
#include <stdio.h>

static char msg[1000];

int aeAssert(const char* funcname, char* file, int line, char* desc)
{
    static int enteredCount = 0;

    enteredCount++;

    if (enteredCount == 1)
    {
        if (desc)
            sprintf(msg, "Assert '%s': %s at %d", desc, funcname, line);
        else
            sprintf(msg, "Assert: %s, %s at %d", desc, funcname, line);
    
        MessageBox(NULL, msg, NULL, MB_ICONEXCLAMATION + MB_OK);
    }
    else
    {
        while (enteredCount > 1)
        {
            Sleep(100); /* 1/10 sec */
        }
    }
    enteredCount--;

    return 0;
}



void aeDebugLog(const char* funcname, int line, const char* desc)
{
    printf("%s (%d): %s\n", funcname, line, desc);
}

void aeDebugLogN(const char* funcname, int line, const char* desc, int val)
{
    printf("%s (%d): %s %#x\n", funcname, line, desc, val);
}

