/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aedebug.h
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#ifndef AEDEBUG_H_
#define AEDEBUG_H_

#include <windows.h>

int  aeAssert(const char* funcname, char* file, int line, char* desc);
void aeDebugLog(const char* funcname, int line, const char* desc);
void aeDebugLogN(const char* funcname, int line, const char* desc, int val);

#define AEASSERT(t) ((t) ? 0 : aeAssert(__PRETTY_FUNCTION__, __FILE__, __LINE__, #t))
#define AEASSERTED(desc) (aeAssert(__PRETTY_FUNCTION__, __FILE__, __LINE__, desc))

#define AEDBG(desc) (aeDebugLog(__PRETTY_FUNCTION__, __LINE__, desc))
#define AEDBGN(desc, val) (aeDebugLogN(__PRETTY_FUNCTION__, __LINE__, desc, val))

#endif
