/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aegraphics.c
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#include "aegraphics.h"
#include <windows.h>
#include "aedebug.h"
#include <stdio.h>


static void aeRectToPlatRect(aeRect_t* aeR, RECT *wR)
{
    wR->left    = aeR->left;
    wR->right   = aeR->right;
    wR->top     = aeR->top;
    wR->bottom  = aeR->bottom;

}


void aegfxDrawString(void* gfxContext, int xPos, int yPos, char* str, aeColor_t color)
{
    HDC hdc = (HDC)gfxContext;

    AEASSERT(hdc);

    TextOut(hdc, xPos, yPos, str, strlen(str));

}



void aegfxFrameRect(void* gfxContext, aeRect_t* rect, aeColor_t color)
{
    RECT wr;
    HDC hdc = (HDC)gfxContext;

    AEASSERT(hdc);

    aeRectToPlatRect(rect, &wr);

    FrameRect(hdc, &wr, GetStockObject(BLACK_PEN));
}



void aegfxFillRect(void* gfxContext, aeRect_t* rect, aeColor_t color)
{
    RECT    wr;
    HDC     hdc = (HDC)gfxContext;
    HBRUSH  hbr;

    AEASSERT(hdc);

    aeRectToPlatRect(rect, &wr);


    /*wr = aeRect_MakeWinRect(&pane->loc);*/

    hbr = (HBRUSH)GetStockObject(LTGRAY_BRUSH);


    FillRect(hdc, &wr, hbr);


}



char aeRect_LocInRect(aeRect_t* rect, int xPos, int yPos)
{
	char inRect = 0;

	if (rect->left <= xPos && xPos <= rect->right && rect->top <= yPos && yPos <= rect->bottom)
		inRect = 1;

	return inRect;
}

