/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aepane.c
 *
 *	
 *
 *
 *
 *------------------------------------------------------------------------------*/
#include "aepane.h"
#include "aedebug.h"

#include <string.h>

/*----------------------------------------------------------------------
Summary
    

Desc
    
----------------------------------------------------------------------*/
void aePane_InitPaneList(aePaneList_t* paneList)
{
    memset(paneList, 0, sizeof(aePaneList_t));

    paneList->hasMouse = -1;
}

/*----------------------------------------------------------------------
Summary
    

Desc
    
----------------------------------------------------------------------*/
void aePane_HandleMouseEvt(aePaneList_t* paneList, void* privateData, void* wndcontext, aeMouseEvt_t mouseEvt, int modifiers, int xPos, int yPos)
{
    int         paneIndex;
    aeRect_t    r;
    aePane_t*   pane;

    AEASSERT(paneList);

    for (paneIndex = 0; paneIndex < paneList->count; paneIndex++)
    {
        pane = &paneList->pane[paneIndex];
        r = pane->loc;

        if (r.left <= xPos && xPos <= r.right && r.top <= yPos && yPos <= r.bottom)
        {
            /* Track which pane had the mouse down */
            if (mouseEvt == aeMouseEvt_eDown)
                paneList->hasMouse = paneIndex;

            /* Only the pane with the mouse down gets mouse move; others get mouse over */
            else if (paneList->hasMouse != paneIndex && mouseEvt == aeMouseEvt_eMove)
                mouseEvt = aeMouseEvt_eOver;

            if (pane->mouseFunc != ((void*)0))
            {
                (pane->mouseFunc)(pane, mouseEvt, modifiers, privateData, wndcontext, xPos, yPos);
            }

            /* Only process one */
            break;
        }
    }
}

