/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aedialogs.h
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#ifndef AEDIALOGS_H_
#define AEDIALOGS_H_
#include "astd.h"

typedef enum
{
    aeuiWndResponse_eOK = 0,
    aeuiWndResponse_eYes,
    aeuiWndResponse_eNo,
    aeuiWndResponse_eCancel,
    aeuiWndResponse_eSave

} aeuiWndResponse_t;

void                aeuiWnd_Error(char* desc, aErr_t err);
void                aeuiWnd_Message(char* desc);
aeuiWndResponse_t   aeuiWnd_DataChangedConfirmClose(const char* desc);
aeuiWndResponse_t   aeuiWnd_AskOKCancel(const char* desc);

aeuiWndResponse_t   aeuiWnd_RequestString(void* instancecontext, void* wndcontext, char* titleStr, char* messageStr, char* nameStr, int nameStrLen);

void aeuiWnd_Window_GetMaxSize(int* maxWidth, int* maxHeight);

void aeuiWnd_BringForward(void* wndcontext);
void aeuiWnd_ChangeTitle(void* wndcontext, const char* title);

void aeuiWnd_TestDialog(void* instancecontext, void* wndcontext);

#endif
