/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  wndlist.c
 *
 *  window manager
 *
 *
 *
 *------------------------------------------------------------------------------*/

#include "aewndlist.h"
#include "aedebug.h"

#define MAX_WND 50

/* Ugh -- clean this up big time */

typedef struct 
{
	void* wnd;
	void* dataA;
    void* dataB;
    aeuiWndType_t wndtype;
} WndList_t;

WndList_t WindowList[MAX_WND];

void aeui_WndList_Init(void)
{

	memset(WindowList, 0, sizeof(WindowList));
}



void aeui_WndList_Add(void* wnd, void* dataA, void* dataB, aeuiWndType_t wndtype)
{
	short	 i;
	
	for (i = 0; i < MAX_WND; i++)
	{
		if (WindowList[i].wnd == NULL)
		{
			WindowList[i].wnd     = wnd;
			WindowList[i].dataA   = dataA;
            WindowList[i].dataB   = dataB;
            WindowList[i].wndtype = wndtype;
			return;
		}
	}
	
}

void* aeui_WndList_GetWndFromDataA(void* dataA)
{
    short	 i;

    for (i = 0; i < MAX_WND; i++)
    {
        if (WindowList[i].dataA == dataA)
            return WindowList[i].wnd;
    }

    return NULL;
}

void* aeui_WndList_GetWndFromDataB(void* dataB)
{
    short	 i;

    for (i = 0; i < MAX_WND; i++)
    {
        if (WindowList[i].dataB == dataB)
            return WindowList[i].wnd;
    }

    return NULL;
}

void* aeui_WndList_GetDataA(void* wnd)
{
	short	 i;
	
	for (i = 0; i < MAX_WND; i++)
	{
		if (WindowList[i].wnd == wnd)
			return WindowList[i].dataA;
	}
	
	return NULL;
}


void* aeui_WndList_GetDataB(void* wnd)
{
	short	 i;
	
	for (i = 0; i < MAX_WND; i++)
	{
		if (WindowList[i].wnd == wnd)
			return WindowList[i].dataB;
	}

	return NULL;
}


void aeui_WndList_Delete(void* wnd)
{
	short	 i;
	
	for (i = 0; i < MAX_WND; i++)
	{
		if (WindowList[i].wnd == wnd)
		{
			WindowList[i].wnd   = NULL;
			WindowList[i].dataA = NULL;
			WindowList[i].dataB = NULL;
			return;
		}
	}
    AEASSERTED("WndList_Delete");
	
}

int aeui_WndList_Type_GetCount(aeuiWndType_t wndtype)
{
    int count = 0;
    int i;

	for (i = 0; i < MAX_WND; i++)
	{
		if (WindowList[i].wnd != NULL && WindowList[i].wndtype == wndtype)
            count++;
	}

    return count;
}

static char aeui_WndList_p_Type_GetListIndexByTypeIndex(aeuiWndType_t wndtype, int typeindex, int* plistindex)
{
    int  foundIndex = -1;
    int  curindex = 0;
    int  i;

    for (i = 0; i < MAX_WND && foundIndex == -1; i++)
    {
		if (WindowList[i].wnd != NULL && WindowList[i].wndtype == wndtype)
        {
            if (curindex == typeindex)
                foundIndex = i;

            curindex++;
        }
    }

    if (foundIndex != -1  && plistindex != NULL)
        *plistindex = foundIndex;

    return foundIndex != -1;
}

void* aeui_WndList_Type_GetWndByTypeIndex(aeuiWndType_t wndtype, int index)
{
    void*   wnd = NULL;
    int     listindex;

    if (aeui_WndList_p_Type_GetListIndexByTypeIndex(wndtype, index, &listindex))
    {
        wnd = WindowList[listindex].wnd;
    }

    return wnd;
}


void* aeui_WndList_Type_GetDataAByTypeIndex(aeuiWndType_t wndtype, int index)
{
    void*   dataA = NULL;
    int     listindex;

    if (aeui_WndList_p_Type_GetListIndexByTypeIndex(wndtype, index, &listindex))
    {
        dataA = WindowList[listindex].dataA;
    }

    return dataA;
}

void* aeui_WndList_Type_GetDataBByTypeIndex(aeuiWndType_t wndtype, int index)
{
    void*   dataB = NULL;
    int     listindex;

    if (aeui_WndList_p_Type_GetListIndexByTypeIndex(wndtype, index, &listindex))
    {
        dataB = WindowList[listindex].dataB;
    }

    return dataB;
}


