/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aedebug.c
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

/*
	window manager
	
	wndlist.h
*/

#ifndef WNDLIST_H_
#define WNDLIST_H_

typedef enum
{
    aeuiWndType_eMain = 0,
    aeuiWndType_eAnimation,
    aeuiWndType_eSequence,

    aeuiWndType_Count
} aeuiWndType_t;

void  aeui_WndList_Init(void);
void  aeui_WndList_Add(void* wnd, void* dataA, void* dataB, aeuiWndType_t wndtype);
void  aeui_WndList_Delete(void* wnd);

void* aeui_WndList_GetDataA(void* wnd);
void* aeui_WndList_GetDataB(void* wnd);
void* aeui_WndList_GetWndFromDataA(void* dataA);
void* aeui_WndList_GetWndFromDataB(void* dataB);

int   aeui_WndList_Type_GetCount(aeuiWndType_t wndtype);
void* aeui_WndList_Type_GetWndByTypeIndex(aeuiWndType_t wndtype, int index);
void* aeui_WndList_Type_GetDataAByTypeIndex(aeuiWndType_t wndtype, int index);
void* aeui_WndList_Type_GetDataBByTypeIndex(aeuiWndType_t wndtype, int index);




#endif
