/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aematrixlayoututils.c
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#ifndef AEMATRIXLAYOUTUTILS_H_
#define AEMATRIXLAYOUTUTILS_H_

#include "aearch.h"


void      aeMatrix_Layout_GetPlatformDefaults(aePlatform_t* platform);
void      aeMatrix_Layout_InitDataRead(aeAnimationData_t* data);
void      aeMatrix_Layout_ComputeLayout(aeLayout_t* layout, int adjustableSize, int cropSize, aeAnimDirection_t direction);

void      aeMatrix_Layout_CreateAnim(aeLayout_t* layout);
void      aeMatrix_Layout_CreateEdit(aeLayout_t* layout, aeAnimationData_t* animData);

void      aeMatrix_Layout_Data_AdvanceElementColor(aeAnimationData_t* animData, int elementIndex);
aeColor_t aeMatrix_Layout_Data_GetElementColor(aeAnimationData_t* animData, int elementIndex);
aeColor_t aeMatrix_Layout_Animation_GetElementColor(aeAnimationData_t* animData, int elementIndex);
int       aeMatrix_Layout_Animation_GetElementColorList(aeAnimationData_t* animData, aeColor_t* colorList, int colorListSize);


#endif /* AEMATRIXLAYOUTUTILS_H_ */

