/*-----------------------------------------------------------------------------
 *
 *  ANIMATOR
 *  LED Animation Sequence Editor
 *
 *  Copyright David D. Kaufman, 2009
 *  
 *  aeslak.c
 *
 *
 *
 *
 *
 *------------------------------------------------------------------------------*/

#include "aeslak.h"
#include "aearch.h"
#include "asig.h"
#include "aearchlist.h"
#include <stdio.h>
#include <string.h>

void aeSLAK_Arch_Register(void)
{
    aeArchitectureInfo_t    archInfo;

    memset(&archInfo, 0, sizeof(archInfo));

    archInfo.signature = ASIG_SLAK;

    archInfo.subtypeFlags = 
        aeAnimSubtypeFlag_eFrameByFrame;

    /* LEDs either on or off */
    archInfo.bitsPerPixel = 1;

    /* Needs two bytes to hold 12 bits */
    archInfo.bytesPerFrame = 2; 

    archInfo.bytesPerEntry[aeAnimSubtypeFlagBit_eFrameByFrame] = 2;
    archInfo.ledsPerEntry[aeAnimSubtypeFlagBit_eFrameByFrame]  = 12;

    aeArchList_Arch_Add(&archInfo);
}

void aeSLAK_CodeGen_Register(void)
{
    /* Soon! */
}


